#include <algorithm>
#include <fstream>
#include <vector>
#include <string>
#include <cstdlib>
#include <time.h>
// Clase que genera un numero aleatorio para el random_shuffle
// de manera que la permutacion siempre sea distinta
class MyRandom {
  public:
    ptrdiff_t operator() (ptrdiff_t max) {
        double tmp;
        tmp = static_cast<double>(rand())
                / static_cast<double>(RAND_MAX);
        return static_cast<ptrdiff_t>(tmp * max);
    }
};

int main(int argc, char **argv)
{

    // Declaracion del vector de string donde se guardaran los tems del archivo
    vector < string > nombres;
    ofstream resultado;
    // Lectura del nombre del archivo mandado al momento de ejecutar
    ifstream archivo(argv[1], ios::nocreate);
    // Archivo html donde se mostrara el resultado de la permutacion
    resultado.open ("permutacion.html");
    string linea;
    int i=0;
    int j;
    if(archivo.fail())
    cerr << "Error al abrir el archivo... " << endl;

    // Se guardan los tems del archivo en el vector de string nombres
    else
    while(!archivo.eof())
    {

        getline(archivo,linea);
        nombres.push_back(linea);
        i++;
    }
    // Semilla para que la permutacion sea siempre diferente
    srand ( time(NULL) );
    MyRandom rd;
    // Se aplica el algoritmo de permutacin del orden de los elementos del vector
    random_shuffle (nombres.begin(),nombres.end(),rd);

    // Se procede a generar la salida en un archivo cgi

    cout << "Content-Type: text/html\n\n";
    cout << "<HTML>\n";
    resultado << "<HTML>\n" << endl;
    cout << "<HEAD>\n";
    resultado <<"<HEAD>\n" << endl;
    cout << "<TITLE> Resultado de la Tmbola </TITLE>\n";
    resultado <<"<TITLE> Resultado de la Tmbola </TITLE>\n" << endl;
    cout << "</HEAD>\n";
    resultado <<"</HEAD>\n" << endl;
    cout << "<BODY>\n";
    resultado <<"<BODY>\n" << endl;
    cout << "<H1>Resultados de las Permutaciones ... </H1> \n";
    resultado <<"<H1>Resultados de las Permutaciones ... </H1> \n" << endl;
    for (j=0; j<i; j++)
    {
    cout << j+1 <<".- ";
    resultado << j+1 <<".- " << endl;
    cout << nombres[j];
    resultado << nombres[j] << endl;
    cout << "<br>\n";
    resultado << "<br>\n" << endl;
    }
    cout << "</BODY>\n";
    resultado << "</BODY>\n" << endl;
    cout << "</HTML>\n";
    resultado << "</HTML>\n" << endl;
    resultado.close();
    archivo.close();
    return 0;
}
